0000                           ;Synertek Tech Notes Scrolling Display Demo
0001                           ;
0002                           ;RAE settings:
0003                           ;
0004                           ;SET $1000 $3FFF $4000 $4FFF $5000
0005                           ;CLEAR
0006                           ;
0007                           ;
0008          .OS              ;Object Store
0009                           ;
0010DISBUF    .DE   $A640      ;
0011SCANDS    .DE   $8906      ;
0012COUNT     .DE   $0011      ;
0013ACCESS    .DE   $8B86      ;
0014                           ;Program Start
0015                           ;
0016          JSR   ACCESS     ;Enable system RAM
0017                           ;
0018          LDY   #$09       ;Take the characters from
0019ONE       LDA   MESSAGE,Y  ;the message space and
0020          STA   DISBUF,Y   ;fill the display with them
0021          DEY              ;
0022          BPL   ONE        ;
0023                           ;
0024CYCLE     LDA   #$FF       ;Set the number of loops we
0025          STA   COUNT      ;hold the message
0026                           ;
0027TWO       JSR   SCANDS     ;Now flash the displays
0028          DEC   COUNT      ;decrement the count for each flash
0029          BNE   TWO        ;
0030                           ;
0031          LDA   DISBUF     ;Save the top number
0032          PHA              ;
0033          LDY   #$00       ;
0034                           ;
0035THREE     LDA   DISBUF+1,Y ;Shift the remaining characters
0036          STA   DISBUF,Y   ;by iterating through the disbuf
0037          INY              ;and incrementing Y register
0038          CPY   #$09       ;for each number of characters
0039          BNE   THREE      ;
0040                           ;
0041          PLA              ;Now place the first character
0042          STA   DISBUF+9   ;in the last memory location
0043                           ;
0044          JMP   CYCLE      ;and do it all over again
0045                           ;
0046                           ;
0047                           ;
0048                           ;Message:
0049                           ;
0050MESSAGE   .BY  $76 $79 $38 ;
0051          .BY  $38 $3F $00 ; "HELLO"
0052          .BY  $00 $00 $00 ;
0053                           ;
0054                           ; $3F ; '0'
0055                           ; $06 ; '1'
0056                           ; $5B ; '2'
0057                           ; $4F ; '3'
0058                           ; $66 ; '4'
0059                           ; $6D ; '5'
0060                           ; $7C ; '6'
0061                           ; $07 ; '7'
0062                           ; $7F ; '8'
0063                           ; $67 ; '9'
0064                           ; $00 ; ' '
0065                           ; $80 ; '.'
0066                           ; $40 ; '-'
0067                           ; $77 ; 'A'
0068                           ; $7C ; 'b'
0069                           ; $39 ; 'C'
0070                           ; $58 ; 'c'
0071                           ; $5E ; 'd'
0072                           ; $79 ; 'E'
0073                           ; $7B ; 'e'
0074                           ; $71 ; 'F'
0075                           ; $7D ; 'G'
0076                           ; $6F ; 'g'
0077                           ; $76 ; 'H'
0078                           ; $74 ; 'h'
0079                           ; $06 ; 'I'
0080                           ; $1E ; 'J'
0081                           ; $74 ; 'K'
0082                           ; $38 ; 'L'
0083                           ; $33 ; 'M'
0084                           ; $27 ; 2nd half
0085                           ; $54 ; 'n'
0086                           ; $3F ; 'O'
0087                           ; $5C ; 'o'
0088                           ; $73 ; 'P'
0089                           ; $67 ; 'q'
0090                           ; $50 ; 'r'
0091                           ; $6D ; 'S'
0092                           ; $46 ; 't'
0093                           ; $3E ; 'U'
0094                           ; $1C ; 'u'
0095                           ; $64 ; 'V'
0096                           ; $52 ; 2nd half
0097                           ; $3C ; 'W'
0098                           ; $1E ; 2nd half
0099                           ; $49 ; 'Ξ'
0100                           ; $6E ; 'Y'
0101                           ; $5B ; 'Z'
0102                           ;
0103                           ;
0104                           ;
0105                           ;
9999          .EN              ;

